module EasySettings
  class Base < ActiveRecord::Base
    self.table_name = table_name_prefix + 'settings'

    serialize :value

    class << self
      def method_missing(method, *args)
        method_name = method.to_s
        if method_name[-1] == '='
          key = method_name[0...-1]
          value = args.first
          self[key]=value
        else
          self[method_name]
        end
      end

      def [](key)
        self.where(key: key).first.try(:value)
      end

      def []=(key, value)
        record = self.where(key: key).first
        if record
          record.update(value: value)
        else
          self.create(key: key, value: value)
        end
      end
    end
  end
end
