require 'rails/generators'
require 'rails/generators/migration'

module EasySettings
  module Generators
    class InstallGenerator < Rails::Generators::Base
      include Rails::Generators::Migration

      desc "Create a EasySettings migration file"
      source_root File.expand_path("../templates", __FILE__)

      def install_settings
        migration_template 'migration.rb', 'db/migrate/easy_settings_migration.rb'
        template 'model.rb', File.join('app/models', "settings.rb")
      end

      def self.next_migration_number(dirname)
        if ActiveRecord::Base.timestamped_migrations
          Time.now.utc.strftime('%Y%m%d%H%M%S')
        else
          '%.3d' % (current_migration_number(dirname) + 1)
        end
      end
    end
  end
end
